proc install {location} {
    global baseDir


    set ifd [open [file join $baseDir src version.txt] r]
    array set versionInfo [read $ifd]
    close $ifd

    set baseName "pyman-"
    set version [format {%d.%d} $versionInfo(major) $versionInfo(minor)]
    if {[info exists versionInfo(patch)]} {
        append version "." $versionInfo(patch)
    }
    append baseName $version ".tm"
    file copy -force -- [file join $baseDir $baseName] [file join $location $baseName]

    return
}

proc build {} {
    global baseDir

    set ifd [open [file join $baseDir src version.txt] r]
    array set versionInfo [read $ifd]
    close $ifd

    set outputName [file join $baseDir pyman-]
    set version [format {%d.%d} $versionInfo(major) $versionInfo(minor)]
    if {[info exists versionInfo(patch)]} {
        append version "." $versionInfo(patch)
    }
    append outputName $version ".tm"
    set ofd [open $outputName w]
    set ifd [open [file join $baseDir src pyman.tcl] r]
    fcopy $ifd $ofd
    puts $ofd {}
    puts $ofd "package provide pyman $version"
    puts $ofd {}
    close $ofd

    return
}

set baseDir [file dirname [info script]]
lassign $argv function location

switch -exact -- $function {
    build {
        build
    }
    install {
        if {$location eq {}} {
            set pattern "*[info tclversion]*"
            foreach dir [::tcl::tm::path list] {
                if {[string match -nocase $pattern $dir]} {
                    set location $dir
                }
            }
        }
        install $location
    }
}
